            #GIT_CMT=bd6a2f6af5a9e266f297b2ae3e64f7265768dfc3
%define dotnet_version     3.1
%define dotnet_release     rh-dotnet31
%define  instDir           /usr/lib/dotnet/NuPkgs
%define  artifactory       https://artifactory.oci.oraclecorp.com/api/nuget/oci-dex-release-nuget-local


Name:       oci-dotnet-sdk		
Version:	5.1.0
Release:    1.el7
Group:		Oracle Cloud Infrastructure
Summary:    Oracle Cloud Infrastructure SDK for .NET
License:	UPL 1.0 and Apache 2.0 
URL:		https://github.com/oracle/oci-dotnet-sdk
Source0:	%{name}-%{version}.tar.gz
Source1:    oci-dotnet-sdk.csproj
Source2:    nuget.config
Source3:    name-mapping.txt
Buildarch:  noarch
AutoReq:    no

BuildRequires:	%{?dotnet_release}-dotnet >= %{dotnet_version} 
Requires:	    %{?dotnet_release}-dotnet >= %{dotnet_version}

%description
The oci-dotnet-sdk provides Oracle Cloud Infrastructure SDK for .NET 
that you can use to manage your Oracle Cloud Infrastructure resources.

Please add or copy  nuget.config to ~/.config/NuGet/nuget.config
 
%prep
%setup -q -n %{name}-%{version}

sed -i '/Commontest/,+1d' oci-dotnet-sdk.sln
#sed -i '/Examples/,+1d' oci-dotnet-sdk.sln

packFile=oci-dotnet-sdk.csproj
cp %{SOURCE1} .

cspFiles=`ls */*.csproj |grep -v Commontest |grep -v Examples`
for csp in $cspFiles; do 
       pkgName=`basename $csp .csproj`
       echo "    <PackageReference Include=\"${pkgName}\" Version=\"%{version}\" />" >>$packFile
done
echo -n "  </ItemGroup>
</Project>
" >>$packFile


%build
unset https_proxy
unset http_proxy

which dotnet ||  source /opt/rh/%{dotnet_release}/enable
dotnet nuget locals all -c
dotnet restore -s %{artifactory}
mv oci-dotnet-sdk.sln oci-dotnet-sdk.sln.old
dotnet restore -s %{artifactory}


%check 
#make unit-test

%install
mkdir -p %{buildroot}%{instDir}
NuPkgs=`find ~/.nuget/ -name "oci.dotnet*.nupkg"`
for nupkg in $NuPkgs; do
    lastname=`basename $nupkg .%version.nupkg|cut -d. -f3`
    cp $nupkg %{buildroot}%{instDir}/OCI.DotNetSDK.${lastname^}.%version.nupkg
done

cp %{SOURCE3} .
NuPkgs=`find ~/.nuget/ -name "*.nupkg"|grep -v "oci.dotnetsdk"`
for nupkg in $NuPkgs; do
    bnameV=`basename $nupkg .nupkg`
    bname=`echo ${bnameV} |sed 's/\.[0-9].*//i'`
    bVersion=`echo ${bnameV/${bname}./}`
    tName=`grep "$bname" name-mapping.txt |awk '{print $2}'`
    [ "$tName" != "" ] || exit 1
    cp $nupkg %{buildroot}%{instDir}/${tName}.${bVersion}.nupkg
done

cp %{SOURCE2} .

%files
%{instDir}/*
%doc *.md *.txt nuget.config Examples/ 

%pre
instDir=/usr/lib/dotnet/NuPkgs
[ -d $instDir ] ||  mkdir -p $instDir 

%changelog
* Tue Oct 20 2020 EL Errata <el-errata_ww@oracle.com> 5.1.0-1
- Update to 5.1.0

* Wed Oct 14 2020 Qing Lin <qing.lin@oracle.com> - 5.0.1-1.el7
- update to 5.0.1

* Wed Oct 14 2020 Qing Lin <qing.lin@oracle.com> -5.0.1-1 
- Build for first RPM release.

* Mon Oct 12 2020 Qing Lin <qing.lin@oracle.com> -4.7.0-1 
- Update to 4.7.0.

* Mon Sep 21 2020 Qing Lin <qing.lin@oracle.com> -4.3.0-1.0.1 
- Pack the prebuild OCI.DotNetSDK nupkgs from OCI artifactory instead.

* Fri Sep 11 2020 Qing Lin <qing.lin@oracle.com> -4.3.0-1 
- Update to 4.3.0
- Add dependency system.identitymodel.tokens.jwt.6.7.1.nupkg
- And its dependencies: system.security.cryptography.cng, microsoft.identitymodel.logging, tokens, jsonwetokens

* Fri Aug 28 2020 Qing Lin <qing.lin@oracle.com> -4.1.0 
- Initial build

